// by Incognito, http://www.beamng.com/threads/8871-Skin-Selector?p=123485&viewfull=1#post123485

function SkinSelector(){}

/*
 *	Problems: Missing Semicolon,
 *	Global Variable !
 *	Not a good idea, bwetter rewrite it to be a objectmember. Initialize the variable in the initialize-methode like this:
 *	this.vehicleLastSkin = {};
 */
vehicleLastSkin = {}

/*
 *	Problem: Global function !
 * 	solve this by rewriting the function like this:
 * 	SkinSelector.prototype.changeMatFile = function(vehicleDir, skinName) {
 *	[...]
 */
function changeMatFile(vehicleDir, skinName) {	
	var code = 'function getSkinsFiles(%vehicleDir, %skinDir) { if ( isFile( %vehicleDir @ "skins/materials_def.cs" ) ) { pathCopy( %vehicleDir @ "skins/materials_def.cs", %vehicleDir @ "materials.cs", false ); } else { return "nope"; } if ( endsWith( %skinDir, "/Default" ) ) { return "default"; } %str = ""; %fileReader = new FileObject(); %fileReader.openForRead( %vehicleDir @ "materials.cs" ); while ( !%fileReader.isEOF() ) { %tmp = %str; %line = %fileReader.readLine(); %str = %tmp NL %line; } %fileReader.close(); for( %file = findFirstFile( %skinDir @ "/*.dds" ); %file !$= ""; %file = findNextFile() ) { %filename = strreplace( %file, %skinDir @ "/", "" ); %str = strreplace( %str, %vehicleDir @ %filename, %file ); } %fileReader = new FileObject(); %fileReader.openForWrite(%vehicleDir @ "materials.cs"); %fileReader.writeLine(%str); %fileReader.close(); return "done"; }'; // replacing in materials.cs
	executeGameEngineCode( code );
	//console.log(vehicleDir +"skins/" +skinName);
	var skinDir = vehicleDir +"skins/" +skinName;
	callGameEngineFuncCallback('getSkinsFiles("' +vehicleDir +'", "' +skinDir +'")', function(result) {
		//console.log('skins=' +result);
		callGameEngineFunc('beamNGReloadCurrentVehicle();');
		$('.SkinSelector').parent().parent().hide( 'slow' );
	});			
}

/*
 *	Same as above
 */
function selectSkin(skinName) {
	callLuaFuncCallback('v.vehicleDirectory', function(vDir) {		
		var materialsFile = vDir +'materials.cs';
		var defaultMaterialsFile = vDir +'skins/materials_def.cs';
		//console.log('matFile=' +materialsFile);
		//console.log('backMatFile=' +defaultMaterialsFile);
		callGameEngineFuncCallback('isFile("' +defaultMaterialsFile +'")', function(res) {
			//console.log('res=' +res);
			if (res == 0) {
				callGameEngineFuncCallback('pathCopy("' +materialsFile +'", "' +defaultMaterialsFile +'", false)', function(res) {
					console.log('backup done');
				});
			}
			changeMatFile( vDir, skinName );
			vehicleLastSkin[vDir] = skinName;
		});
	});
}

/*
 *	Same as above
 */
function updSkinsList() {
/*
 *	Using a global id like #skins isn't a good idea, it could be used by anotherapp, also instances of your app override this.
 *	See line 93 for a solution.
 *	then the the line will look like:
 *		this.skinList.find('option').remove();
 *	You could shorten the line by using:
 *		this.skinList.empthy();
 */
	$('#skins')
		.find('option')
		.remove();
	callLuaFuncCallback('v.vehicleDirectory', function(vDir) {		
		callGameEngineFuncCallback( 'getDirectoryList("' +vDir +"skins/" +'")', function(arg) {
			$('#skins').append('<option value="Default">Default</option>');
			if ( arg == "" ) {
				return;
			}
			var lastSkin = "";
			if ( vDir in vehicleLastSkin ) {
				lastSkin = vehicleLastSkin[vDir];
			}
			//console.log(arg);
			var skinsArr = arg.split('	');
			$('#skins').append(option);			
			for ( var i = 0; i < skinsArr.length; i++ ) {
				var skin = skinsArr[i];
				var option = $("<option></option>")
					.attr("value", skin)
					.text(skin);
				if ( skin == lastSkin ) {
					option.attr("selected", "1");
				}
				$('#skins').append(option);
			}
		});
	});	
}

SkinSelector.prototype.initialize = function(){
/*
 *	jQuery destroys the 'this' reference on its eventhandlers, so you need to save it
 *		var self = this;
 */

	$('<label>Skin:</label>').appendTo(this.rootElement);
/*
 *	Using global id's is a bad idea. Better save the jqueryselectors in object attributes. It's faster and won't create problems when using more than one instance or another app uses the same id.
 *	Just replace the line below with:
 *		this.skinList = $('<select></select>').appendTo(this.rootElement);
 *	With this.skinList you'll have access to the element in the whole app, without using id's.
 */
	$('<select id="skins"></select>').appendTo(this.rootElement);
/*
 *	since you don't need a reference on the button, just remove the id.
 */
	$('<button id="selectSkinBtn">Select</button>').appendTo(this.rootElement).click(function(){
		console.log('selectSkinBtn click');
/*
 *	with the local variable self you fget access to your app:
 *		var selectedSkin = self.skinList.find('option:selected').val();
 *		self.selectSkin( selectedSkin );
 */
		var selectedSkin = $("#skins option:selected").val();
		selectSkin( selectedSkin );
	});
/*
 *	same pronciple as above: remove the id, use self in the anonymous method
 */
	$('<button id="hide">Hide</button>').appendTo(this.rootElement).click(function(){
		$('.SkinSelector').parent().parent().hide( 'slow' );
	});
	$( document ).bind( "keydown", function(evt) {
		if ( evt.ctrlKey && evt.keyCode == 83 )
		{
			//console.log('1');
			//console.log($(this).width());
/*
 *	You shouldn't modify the behaviour of the appsystem, hiding this.rootElement should do the trick too.
 */
			if ($('.SkinSelector').is(':visible'))
			{
				$('.SkinSelector').parent().parent().hide( 'slow' );
			}
			else
			{
				$('.SkinSelector').parent().parent().show( 'slow' );
				updSkinsList();
			}
		}
	});
		
	console.log("SkinSelector inizialize");
	updSkinsList();	
};
/*
 *	If you don't use any streams you can remove this method :)
 */
SkinSelector.prototype.update = function(streams) {

}